#include "la_includes.h"
#include "la_geometry_undo.h"

#include <math.h>


uint *la_compute_neighbor(uint *ref, uint ref_count, uint vertex_count, egreal *vertex)
{
	uint i, j, cor, clear = 0, *n, *v, a, b;
	uint tq1, tq2;
	n = malloc((sizeof *n) * ref_count * 4);
	for(i = 0; i < ref_count * 4; i++)
		n[i] = ~0u;
	v = malloc((sizeof *v) * vertex_count);
	for(i = 0; i < vertex_count; i++)
		v[i] = ~0u;

	while(clear < ref_count * 4)
	{
		for(i = 0; i < ref_count * 4;)
		{
			if(ref[i] < vertex_count && ref[i + 1] < vertex_count && ref[i + 2] < vertex_count && vertex[ref[i] * 3] != V_REAL64_MAX && vertex[ref[i + 1] * 3] != V_REAL64_MAX && vertex[ref[i + 2] * 3] != V_REAL64_MAX)
			{
				if(ref[i + 3] < vertex_count && vertex[ref[i + 3] * 3] != V_REAL64_MAX)
					tq1 = 4;
				else
					tq1 = 3;
	
				for(j = 0; j < tq1; j++)
				{
					cor = v[ref[i]];
					if(cor == ~0u)
					{
						if(n[i] == ~0u || n[(i / 4) * 4 + (i + tq1 - 1) % tq1] == ~0u)
							v[ref[i]] = i;
					}
					else if(cor == i)
					{
						v[ref[i]] = ~0u;
					}
					else
					{
						if(ref[((cor / 4) * 4) + 3] < vertex_count && vertex[ref[((cor / 4) * 4) + 3] * 3] != V_REAL64_MAX)
							tq2 = 4;
						else
							tq2 = 3;
						a = (i / 4) * 4;
						b = (cor / 4) * 4;
						if((n[cor] == ~0u || n[a + (i + tq1 - a - 1) % tq1] == ~0u) && ref[a + (i + tq1 - a - 1) % tq1] == ref[b + (cor + 1 - b) % tq2])
						{
							n[a + (i + tq1 - a - 1) % tq1] = cor;
							n[cor] = a + (i + tq1 - a - 1) % tq1;
							clear = 0;
							if(n[b + (cor + tq2 - 1) % tq2] != ~0u)
							{
								if(n[i] == ~0u)
									v[ref[i]] = i;
								else
									v[ref[i]] = ~0u;
							}
						}
						if((n[i] == ~0u || n[b + (cor + tq2 - b - 1) % tq2] == ~0u) && ref[a + (i - a + 1) % tq1] == ref[b + (cor + tq2 - b - 1) % tq2])
						{
							n[i] = b + (cor + tq2 - b - 1) % tq2;
							n[b + (cor + tq2 - b - 1) % tq2] = i;
							clear = 0;	
							if(n[cor] != ~0u)
							{
								if(n[a + (i + tq1 - a - 1) % tq1] == ~0u)
									v[ref[i]] = i;
								else
									v[ref[i]] = ~0u;
							}
						}
					}
					i++;
				}
				i = i + 4 - tq1;
			}else
				i += 4;
			clear++;
		}
	}
	free(v);
	return n; 
}
	
void la_t_poly_triangulate(void)
{
	uint i, id, side;
	uint32 vertex_count, ref_count, *ref, *crease;
	double *vertex, v[3], d, d2, r, r2;

	udg_get_geometry(&vertex_count, &ref_count, &vertex, &ref, &crease);

	for(i = 0; i < ref_count * 4; i += 4)
	{
		if(ref[i] < vertex_count && ref[i + 1] < vertex_count && ref[i + 2] < vertex_count && vertex[ref[i] * 3] != V_REAL64_MAX && vertex[ref[i + 1] * 3] != V_REAL64_MAX && vertex[ref[i + 2] * 3] != V_REAL64_MAX)
		{
			if(ref[i + 3] < vertex_count && vertex[ref[i + 3] * 3] != V_REAL64_MAX)
			{
				if(udg_get_select(ref[i]) > 0.1 && udg_get_select(ref[i + 1]) > 0.1 && udg_get_select(ref[i + 2]) > 0.1 && udg_get_select(ref[i + 3]) > 0.1)
				{
					id = udg_find_empty_slot_polygon();
					v[0] = vertex[ref[i] * 3 + 0] - vertex[ref[i + 2] * 3 + 0];
					v[1] = vertex[ref[i] * 3 + 1] - vertex[ref[i + 2] * 3 + 1];
					v[2] = vertex[ref[i] * 3 + 2] - vertex[ref[i + 2] * 3 + 2];
					r = v[0] + v[1] + v[2];
					if(r < 0)
						r = -r;
					d = sqrt(v[0] * v[0] + v[1] * v[1] + v[2] * v[2]);
					v[0] = vertex[ref[i + 1] * 3 + 0] - vertex[ref[i + 3] * 3 + 0];
					v[1] = vertex[ref[i + 1] * 3 + 1] - vertex[ref[i + 3] * 3 + 1];
					v[2] = vertex[ref[i + 1] * 3 + 2] - vertex[ref[i + 3] * 3 + 2];
					d2 = sqrt(v[0] * v[0] + v[1] * v[1] + v[2] * v[2]);
					r2 = v[0] + v[1] + v[2];
					if(r2 < 0)
						r2 = -r2;
					if(d > d2 * 1.1)
						side = 1;
					else if(d2 > d * 1.1)
						side = 0;
					else if(r > r2)
						side = 0;
					else
						side = 1;
					if(side == 0)
					{
						udg_polygon_set(i / 4, ref[i], ref[i + 1], ref[i + 2], ~0u);
						udg_crease_set(i / 4, crease[i], crease[i + 1], 0, 0);
						udg_polygon_set(id, ref[i + 2], ref[i + 3], ref[i], ~0u);
						udg_crease_set(id, crease[i + 2], crease[i + 3], 0, 0);
					}else
					{
						udg_polygon_set(i / 4, ref[i], ref[i + 1], ref[i + 3], ~0u);
						udg_crease_set(i / 4, crease[i], 0, crease[i + 3], 0);
						udg_polygon_set(id, ref[i + 1], ref[i + 2], ref[i + 3], ~0u);
						udg_crease_set(id, crease[i + 1], crease[i + 2], 0, 0);
					}
				}
			}
		}
	}
}


uint la_t_poly_quad_corner_test(double *a, double *b, double *c)
{
	double v[3], v2[3], v3[3], r0, r1, r2;
	v[0] = b[0] - a[0];
	v[1] = b[1] - a[1];
	v[2] = b[2] - a[2];
	r0 = sqrt(v[0] * v[0] + v[1] * v[1] + v[2] * v[2]);
	v[0] /= r0;
	v[1] /= r0;
	v[2] /= r0;
	v2[0] = c[0] - b[0];
	v2[1] = c[1] - b[1];
	v2[2] = c[2] - b[2];
	r0 = sqrt(v2[0] * v2[0] + v2[1] * v2[1] + v2[2] * v2[2]);
	v2[0] /= r0;
	v2[1] /= r0;
	v2[2] /= r0;
	v3[0] = a[0] - c[0];
	v3[1] = a[1] - c[1];
	v3[2] = a[2] - c[2];
	r0 = sqrt(v3[0] * v3[0] + v3[1] * v3[1] + v3[2] * v3[2]);
	v3[0] /= r0;
	v3[1] /= r0;
	v3[2] /= r0;
	r0 = v[0] * -v3[0] + v[1] * -v3[1] + v[2] * -v3[2];
	r1 = v2[0] * -v[0] + v2[1] * -v[1] + v2[2] * -v[2];
	r2 = v3[0] * -v2[0] + v3[1] * -v2[1] + v3[2] * -v2[2];

	if(r0 > r1)
	{
		if(r1 > r2)
			return 2;
		else
			return 1;
	}else
	{
		if(r0 > r2)
			return 2;
		else
			return 0;
	}
}

void la_t_poly_find_quads(void)
{
	uint i, j, other, otherj;
	uint32 vertex_count, ref_count, *n, *ref, *crease;
	double *vertex;
	udg_get_geometry(&vertex_count, &ref_count, &vertex, &ref, &crease);
	n = la_compute_neighbor(ref, ref_count, vertex_count, vertex);
	for(i = 0; i < ref_count * 4; i += 4)
	{
		if(ref[i] < vertex_count && ref[i + 1] < vertex_count && ref[i + 2] < vertex_count && vertex[ref[i] * 3] != V_REAL64_MAX && vertex[ref[i + 1] * 3] != V_REAL64_MAX && vertex[ref[i + 2] * 3] != V_REAL64_MAX)
		{
			if(ref[i + 3] >= vertex_count || vertex[ref[i + 3] * 3] == V_REAL64_MAX)
			{
				if(udg_get_select(ref[i]) > 0.1 && udg_get_select(ref[i + 1]) > 0.1 && udg_get_select(ref[i + 2]) > 0.1)
				{
					j = (la_t_poly_quad_corner_test(&vertex[ref[i] * 3], &vertex[ref[i + 1] * 3], &vertex[ref[i + 2] * 3]) + 1) % 3;
					if(n[i + j] != ~0u && n[i + j] < i + j && crease[i + j] == 0)
					{
						other = (n[i + j] / 4) * 4;
						otherj = n[i + j] - other;
						if(udg_get_select(ref[other + (otherj + 2) % 3]) > 0.1)
						{
							if(ref[(other / 4) * 4 + 3] >= vertex_count || vertex[ref[(other / 4) * 4 + 3] * 3] == V_REAL64_MAX)
							{
								if(0 == (la_t_poly_quad_corner_test(&vertex[ref[other + otherj] * 3], &vertex[ref[other + (otherj + 1) % 3] * 3], &vertex[ref[other + (otherj + 2) % 3] * 3]) + 1) % 3)
								{
									udg_polygon_set(i / 4, ref[i + (j + 1) % 3], ref[i + (j + 2) % 3], ref[i + j], ref[other + (otherj + 2) % 3]);
									udg_crease_set(i / 4, crease[i + (j + 1) % 3], crease[i + (j + 2) % 3], crease[other + (otherj + 1) % 3], crease[other + (otherj + 2) % 3]);
									udg_polygon_delete(other / 4);
								}
							}
						}
					}
				}
			}
		}
	}
}

void la_t_poly_auto_crease(void)
{
	uint i, j;
	uint32 vertex_count, ref_count, *n, *ref, *crease, poly, out_crease[4];
	double *vertex, r, x, y, z, x2, y2, z2, x3, y3, z3, *normals;

	udg_get_geometry(&vertex_count, &ref_count, &vertex, &ref, &crease);
	n = la_compute_neighbor(ref, ref_count, vertex_count, vertex);
	normals = malloc((sizeof *normals) * ref_count * 30);

	for(i = 0; i < ref_count * 4; i += 4)
	{
		if(ref[i] < vertex_count && ref[i + 1] < vertex_count && ref[i + 2] < vertex_count && vertex[ref[i] * 3] != V_REAL64_MAX && vertex[ref[i + 1] * 3] != V_REAL64_MAX && vertex[ref[i + 2] * 3] != V_REAL64_MAX)
		{
			x = vertex[ref[i] * 3 + 0] - vertex[ref[i + 1] * 3 + 0];
			y = vertex[ref[i] * 3 + 1] - vertex[ref[i + 1] * 3 + 1];
			z = vertex[ref[i] * 3 + 2] - vertex[ref[i + 1] * 3 + 2];
			r = sqrt(x * x + y * y + z * z);
			x = x / r;
			y = y / r;
			z = z / r;
			x2 = vertex[ref[i + 2] * 3 + 0] - vertex[ref[i + 1] * 3 + 0];
			y2 = vertex[ref[i + 2] * 3 + 1] - vertex[ref[i + 1] * 3 + 1];
			z2 = vertex[ref[i + 2] * 3 + 2] - vertex[ref[i + 1] * 3 + 2];
			r = sqrt(x2 * x2 + y2 * y2 + z2 * z2);
			x2 = x2 / r;
			y2 = y2 / r;
			z2 = z2 / r;
			x3 = y * z2 - z * y2;
			y3 = z * x2 - x * z2;
			z3 = x * y2 - y * x2;
			r = sqrt(x3 * x3 + y3 * y3 + z3 * z3);
			normals[(i / 4) * 3 + 0] = y3 / r;
			normals[(i / 4) * 3 + 1] = z3 / r;
			normals[(i / 4) * 3 + 2] = x3 / r;
		}
	}

	for(i = 0; i < ref_count * 4; i += 4)
	{
		if(ref[i] < vertex_count && ref[i + 1] < vertex_count && ref[i + 2] < vertex_count && vertex[ref[i] * 3] != V_REAL64_MAX && vertex[ref[i + 1] * 3] != V_REAL64_MAX && vertex[ref[i + 2] * 3] != V_REAL64_MAX)
		{
			if(ref[i + 3] < vertex_count && vertex[ref[i + 3] * 3] != V_REAL64_MAX)
				poly = 4;
			else
				poly = 3;

			for(j = 0; j < poly; j++)
			{
				if(udg_get_select(ref[i + j]) > 0.1 && udg_get_select(ref[i + (j + 1) % poly]) && n[i + j] != ~0u)
				{
				/*	printf("normals %i %f\n", j , normals[(n[i + j] / 4) * 3 + 0]
						* normals[(i / 4) * 3 + 0]
						+ normals[(n[i + j] / 4) * 3 + 1]
						* normals[(i / 4) * 3 + 1]
						+ normals[(n[i + j] / 4) * 3 + 2]
						* normals[(i / 4) * 3 + 2]);*/
					if(normals[(n[i + j] / 4) * 3 + 0]
						* normals[(i / 4) * 3 + 0]
						+ normals[(n[i + j] / 4) * 3 + 1]
						* normals[(i / 4) * 3 + 1]
						+ normals[(n[i + j] / 4) * 3 + 2]
						* normals[(i / 4) * 3 + 2] > 0.5)
						out_crease[j] = 0;
					else
						out_crease[j] = ~0u;
				}else
					out_crease[j] = crease[i + j];
			}
		//	printf("set = %u %u %u %u\n", out_crease[0], out_crease[1], out_crease[2], out_crease[3]);
			if(out_crease[0] != crease[i] || out_crease[1] != crease[i + 1] || out_crease[2] != crease[i + 2] || out_crease[3] != crease[i + 3])
				udg_crease_set(i / 4, out_crease[0], out_crease[1], out_crease[2], out_crease[3]);
		}
	}
	free(normals);
}
