#! /bin/env python
#
# Simple little simplistic client to test that unsubscribing
# from curves stops updates from coming.
#
# Note: this code is not necessarily an end-user friendly
# testing application; it might require hands-on code changes
# to actually expose problems.
#

import time
import verse as v

def cb_connect_accept(my_avatar, address, host_id):
	print
	print "Connected alright. Listing curves."
	v.send_node_list(1 << v.CURVE)
	v.send_node_name_set(my_avatar, "curvetest")

def cb_node_create(node_id, type, owner):
	if type == v.CURVE:
		v.send_node_subscribe(node_id)

def cb_c_curve_create(node_id, curve_id, name, dimensions):
	print "There's a curve", name, "with", dimensions, "dimensions"
	v.send_c_curve_subscribe(node_id, curve_id)
	global the_curves
	the_curves.append((node_id, curve_id))

def cb_c_key_set(node_id, curve_id, key_id, dimensions, pre_value, pre_pos, value, pos, post_value, post_pos):
	print "Key set in ", curve_id

if __name__ == "__main__":
	the_curves = []
	v.callback_set(v.SEND_CONNECT_ACCEPT,	cb_connect_accept)
	v.callback_set(v.SEND_NODE_CREATE,	cb_node_create)
	v.callback_set(v.SEND_C_CURVE_CREATE,	cb_c_curve_create)
	v.callback_set(v.SEND_C_KEY_SET,	cb_c_key_set)

	v.send_connect("curvetest", "<secret>", "localhost", 0)

	dur = 35
	print "Receiving curve ops for " + str(dur) + " seconds..."
	start = time.time()
	while time.time() - start < dur:
		v.callback_update(100000)

	print "Unsubscribing from curves..."
	for c in the_curves:
		print " ", c
		v.send_c_curve_unsubscribe(c[0], c[1])

	dur = 35
	print "Trying to receive curve ops for enother " + str(dur) + " seconds..."
	start = time.time()
	while time.time() - start < dur:
		v.callback_update(100000)

	v.send_connect_terminate("localhost", "Done")
	while v.session_get_size() > 10: v.callback_update()
