#! /bin/env python
#
# Simple little simplistic client to test that unsubscribing
# from object method groups really stops updates from coming.
#
# Note: this code is not necessarily an end-user friendly
# testing application; it might require hands-on code changes
# to actually expose problems.
#

import time
import verse as v

def cb_connect_accept(my_avatar, address, host_id):
	print
	print "Connected alright. Listing objects."
	v.send_node_list(1 << v.OBJECT)
	v.send_node_name_set(my_avatar, "mgrouptest")

def cb_node_create(node_id, type, owner):
	if type == v.OBJECT:
		v.send_node_subscribe(node_id)

def cb_o_method_group_create(node_id, group_id, name):
	print "There's a method group", group_id, " in ", node_id, "-- subscribing"
	the_groups.append((node_id, group_id))
	v.send_o_method_group_subscribe(node_id, group_id)

def cb_o_method_create(node_id, group_id, method_id, name, params):
	print "Method created"

def cb_o_method_destroy(node_id, group_id, method_id):
	print "Method destroyed"

if __name__ == "__main__":
	the_groups = []
	v.callback_set(v.SEND_CONNECT_ACCEPT,		cb_connect_accept)
	v.callback_set(v.SEND_NODE_CREATE,		cb_node_create)
	v.callback_set(v.SEND_O_METHOD_GROUP_CREATE,	cb_o_method_group_create)
	v.callback_set(v.SEND_O_METHOD_CREATE,		cb_o_method_create)
	v.callback_set(v.SEND_O_METHOD_DESTROY,		cb_o_method_destroy)

	v.send_connect("mgrouptest", "<secret>", "localhost", 0)

	dur = 35
	print "Receiving method group ops for " + str(dur) + " seconds..."
	start = time.time()
	while time.time() - start < dur:
		v.callback_update(100000)

	print "Unsubscribing from method groups..."
	for g in the_groups:
		print " ", g
		v.send_o_method_group_unsubscribe(g[0], g[1])

	dur = 35
	print "Trying to receive group ops for enother " + str(dur) + " seconds..."
	start = time.time()
	while time.time() - start < dur:
		v.callback_update(100000)

	v.send_connect_terminate("localhost", "Done")
	while v.session_get_size() > 10: v.callback_update()
