/*
 * Simplistic test of Verse's ping command.
*/

#include <stdio.h>
#include <string.h>

#include "verse.h"

static void cb_ping(void *user, const char *address, const char *message)
{
	printf("Got ping: '%s'\n", message);
}

int main(int argc, char *argv[])
{
	int	i;
	const char	*server ="localhost";

	verse_callback_set(verse_send_ping,	cb_ping,	NULL);

	for(i = 1; argv[i] != NULL; i++)
	{
		if(strncmp(argv[i], "-ip=", 4) == 0)
			server = argv[i] + 4;
		else if(strncmp(argv[i], "-ping=", 6) == 0)
			verse_send_ping(server, argv[i] + 6);
		else
			printf("Unknown option '%s'\n", argv[i]);
	}

	while(1)
	{
		verse_callback_update(10000);
	}
	return EXIT_SUCCESS;
}
