#! /bin/env python
#
# Simple little simplistic client to test that unsubscribing
# from tag groups really stops updates from coming.
#
# Note: this code is not necessarily an end-user friendly
# testing application; it might require hands-on code changes
# to actually expose problems.
#

import time
import verse as v

def cb_connect_accept(my_avatar, address, host_id):
	print
	print "Connected alright. Listing objects (for simplicity)."
	v.send_node_list(1 << v.OBJECT)
	v.send_node_name_set(my_avatar, "tgrouptest")

def cb_node_create(node_id, type, owner):
	if type == v.OBJECT:
		v.send_node_subscribe(node_id)

def cb_tag_group_create(node_id, group_id, name):
	print "There's a tag group", group_id, " in ", node_id, "-- subscribing"
	the_groups.append((node_id, group_id))
	v.send_tag_group_subscribe(node_id, group_id)

def cb_tag_create(node_id, group_id, tag_id, name, type, value):
	print "Tag created"

def cb_tag_destroy(node_id, group_id, tag_id):
	print "Tag destroyed"

if __name__ == "__main__":
	the_groups = []
	v.callback_set(v.SEND_CONNECT_ACCEPT,	cb_connect_accept)
	v.callback_set(v.SEND_NODE_CREATE,	cb_node_create)
	v.callback_set(v.SEND_TAG_GROUP_CREATE,	cb_tag_group_create)
	v.callback_set(v.SEND_TAG_CREATE,	cb_tag_create)
	v.callback_set(v.SEND_TAG_DESTROY,	cb_tag_destroy)

	v.send_connect("tgrouptest", "<secret>", "localhost", 0)

	dur = 35
	print "Receiving tag group ops for " + str(dur) + " seconds..."
	start = time.time()
	while time.time() - start < dur:
		v.callback_update(100000)

	print "Unsubscribing from tag groups..."
	for g in the_groups:
		print " ", g
		v.send_tag_group_unsubscribe(g[0], g[1])

	dur = 35
	print "Trying to receive group ops for enother " + str(dur) + " seconds..."
	start = time.time()
	while time.time() - start < dur:
		v.callback_update(100000)

	print "There, I'm done. Disconnecting"

	v.send_connect_terminate("localhost", "Done")
	while v.session_get_size() > 10: v.callback_update()
