#! /bin/env python
#
# Simple little simplistic client to test that unsubscribing from object
# transform updates really stops them coming. It seems to.
#
# Note: this code is not necessarily an end-user friendly
# testing application; it might require hands-on code changes
# to actually expose problems.

import time
import verse as v

def cb_connect_accept(my_avatar, address, host_id):
	print
	print "Connected alright. Listing objects."
	v.send_node_list(1 << v.OBJECT)
	v.send_node_name_set(my_avatar, "xformtest")

def cb_node_create(node_id, type, owner):
	if type == v.OBJECT:
		global the_trans
		v.send_o_transform_subscribe(node_id, v.FORMAT_REAL64)
		print "Subscribed to transform of object", node_id
		the_trans.append(node_id)

def cb_o_transform_pos(node_id, time_s, time_f, pos, speed, accel, drag_normal, drag):
	print "transform:", node_id, time_s, time_f, pos, speed, accel, drag_normal, drag

if __name__ == "__main__":
	the_trans = []
	v.callback_set(v.SEND_CONNECT_ACCEPT,		cb_connect_accept)
	v.callback_set(v.SEND_NODE_CREATE,		cb_node_create)
	v.callback_set(v.SEND_O_TRANSFORM_POS_REAL32,	cb_o_transform_pos)
	v.callback_set(v.SEND_O_TRANSFORM_POS_REAL64,	cb_o_transform_pos)

	v.send_connect("xformtest", "<secret>", "localhost", 0)

	dur = 35
	print "Receiving transforms for " + str(dur) + " seconds..."
	start = time.time()
	while time.time() - start < dur:
		v.callback_update(100000)

	print "Unsubscribing from transforms..."
	for o in the_trans:
		print " ", o
		v.send_o_transform_unsubscribe(o, v.FORMAT_REAL64)

	dur = 35
	print "Trying to receive transforms for enother " + str(dur) + " seconds..."
	start = time.time()
	while time.time() - start < dur:
		v.callback_update(100000)

	v.send_connect_terminate("localhost", "Done")
	while v.session_get_size() > 10: v.callback_update()
